;;; console-log.lisp
;;; 12-18-2003 SVS
;;; For writing messages to the debugger console in OSX. This does nothing
;;;   if run from OS9.

(in-package :ccl)

(export '(console-log *do-console-logs*))

(defparameter *do-console-logs* t ; #'caps-lock-key-p is useful too
  "True if you want console-logs to work.
    Assign this to be a thunk function if you want the results of calling that
    function to determine whether console logs work.")

(defun console-log (fmt-control-string &rest fmt-args)
  "Prints given format control string and args to debugger console in OSX.
   provided that *do-console-logs* is non-nil, and if it's a function of no args,
   calling that function returns true. Console-log returns true if it succeeded."
  (when (and *do-console-logs*
             (if (functionp *do-console-logs*)
               (funcall *do-console-logs*)
               t))
    (write-string-to-file-descriptor ; Gary's magic
     (apply #'format nil fmt-control-string fmt-args))))

; (setf *do-console-logs* #'caps-lock-key-p) ; useful if you only want to see log
;  messages while caps-lock is down