; -*- Mode:Lisp; Package:CCL; -*-

; SANEtraps.lisp - Trap constants for SANE.
;; Copyright 1987-1988, Coral Software Corp.
;; Copyright 1989-1994 Apple Computer, Inc.
;; Copyright 1995 Digitool, Inc.


; 8/24/91  gb just define constants, don't export them.
; 11/23/89 gz *dispatching-traps*
; 8/16/88  gz wondered if we really need this, fixed it anyway.
; 07/18/87 gz export everything.
; 01/12/87 gz New file

(in-package :ccl)

(eval-when (eval compile)
  (require 'backquote))


(defconstant $foadd #x0000)
(defconstant $fosub #x0002)
(defconstant $fomul #x0004)
(defconstant $fodiv #x0006)
(defconstant $focmp #x0008)
(defconstant $focpx #x000A)
(defconstant $forem #x000C)
(defconstant $foz2x #x000E)
(defconstant $fox2z #x0010)
(defconstant $fosqrt #x0012)
(defconstant $forti #x0014)
(defconstant $fotti #x0016)
(defconstant $foscalb #x0018)
(defconstant $fologb #x001A)
(defconstant $foclass #x001C)

(defconstant $fosetenv #x0001)
(defconstant $fogetenv #x0003)
(defconstant $fosethv #x0005)
(defconstant $fogethv #x0007)
(defconstant $fod2b #x0009)
(defconstant $fob2d #x000B)
(defconstant $foneg #x000D)
(defconstant $foabs #x000F)
(defconstant $focpysgn #x0011)
(defconstant $fonext #x0013)
(defconstant $fosetxcp #x0015)
(defconstant $foprocentry #x0017)
(defconstant $foprocexit #x0019)
(defconstant $fotestxcp #x001B)

(defconstant $ffext #x0000)
(defconstant $ffdbl #x0800)
(defconstant $ffsgl #x1000)
(defconstant $ffint #x2000)
(defconstant $fflng #x2800)
(defconstant $ffcomp #x3000)

(defconstant $fcext #x0000)
(defconstant $fcdbl #x4000)
(defconstant $fcsgl #x8000)

(defconstant _faddx (%i+ $foadd $ffext))
(defconstant _faddd (%i+ $foadd $ffdbl))
(defconstant _fadds (%i+ $foadd $ffsgl))
(defconstant _faddc (%i+ $foadd $ffcomp))
(defconstant _faddi (%i+ $foadd $ffint))
(defconstant _faddl (%i+ $foadd $fflng))

(defconstant _fsubx (%i+ $fosub $ffext))
(defconstant _fsubd (%i+ $fosub $ffdbl))
(defconstant _fsubs (%i+ $fosub $ffsgl))
(defconstant _fsubc (%i+ $fosub $ffcomp))
(defconstant _fsubi (%i+ $fosub $ffint))
(defconstant _fsubl (%i+ $fosub $fflng))

(defconstant _fmulx (%i+ $fomul $ffext))
(defconstant _fmuld (%i+ $fomul $ffdbl))
(defconstant _fmuls (%i+ $fomul $ffsgl))
(defconstant _fmulc (%i+ $fomul $ffcomp))
(defconstant _fmuli (%i+ $fomul $ffint))
(defconstant _fmull (%i+ $fomul $fflng))

(defconstant _fdivx (%i+ $fodiv $ffext))
(defconstant _fdivd (%i+ $fodiv $ffdbl))
(defconstant _fdivs (%i+ $fodiv $ffsgl))
(defconstant _fdivc (%i+ $fodiv $ffcomp))
(defconstant _fdivi (%i+ $fodiv $ffint))
(defconstant _fdivl (%i+ $fodiv $fflng))

(defconstant _fsqrtx $fosqrt)

(defconstant _frintx $forti)
(defconstant _ftintx $fotti)

(defconstant _fremx (%i+ $forem $ffext))
(defconstant _fremd (%i+ $forem $ffdbl))
(defconstant _frems (%i+ $forem $ffsgl))
(defconstant _fremc (%i+ $forem $ffcomp))
(defconstant _fremi (%i+ $forem $ffint))
(defconstant _freml (%i+ $forem $fflng))
(defconstant _flogbx $fologb)
(defconstant _fscalbx (%i+ $foscalb $ffint))
(defconstant _fcpysgnx $focpysgn)
(defconstant _fnegx $foneg)
(defconstant _fabsx $foabs)

(defconstant _fnexts (%i+ $fonext $ffsgl))
(defconstant _fnextd (%i+ $fonext $ffdbl))
(defconstant _fnextx (%i+ $fonext $ffext))
(defconstant _fx2x (%i+ $foz2x $ffext))
(defconstant _fd2x (%i+ $foz2x $ffdbl))
(defconstant _fs2x (%i+ $foz2x $ffsgl))
(defconstant _fc2x (%i+ $foz2x $ffcomp))
(defconstant _fi2x (%i+ $foz2x $ffint))
(defconstant _fl2x (%i+ $foz2x $fflng))

(defconstant _fx2d (%i+ $fox2z $ffdbl))
(defconstant _fx2s (%i+ $fox2z $ffsgl))
(defconstant _fx2c (%i+ $fox2z $ffcomp))
(defconstant _fx2i (%i+ $fox2z $ffint))
(defconstant _fx2l (%i+ $fox2z $fflng))

(defconstant _fx2dec (%i+ $fob2d $ffext))
(defconstant _fd2dec (%i+ $fob2d $ffdbl))
(defconstant _fs2dec (%i+ $fob2d $ffsgl))
(defconstant _fc2dec (%i+ $fob2d $ffcomp))
(defconstant _fi2dec (%i+ $fob2d $ffint))
(defconstant _fl2dec (%i+ $fob2d $fflng))

(defconstant _fdec2x (%i+ $fod2b $ffext))
(defconstant _fdec2d (%i+ $fod2b $ffdbl))
(defconstant _fdec2s (%i+ $fod2b $ffsgl))
(defconstant _fdec2c (%i+ $fod2b $ffcomp))
(defconstant _fdec2i (%i+ $fod2b $ffint))
(defconstant _fdec2l (%i+ $fod2b $fflng))

(defconstant _fcmpx (%i+ $focmp $ffext))
(defconstant _fcmpd (%i+ $focmp $ffdbl))
(defconstant _fcmps (%i+ $focmp $ffsgl))
(defconstant _fcmpc (%i+ $focmp $ffcomp))
(defconstant _fcmpi (%i+ $focmp $ffint))
(defconstant _fcmpl (%i+ $focmp $fflng))

(defconstant _fcpxx (%i+ $focpx $ffext))
(defconstant _fcpxd (%i+ $focpx $ffdbl))
(defconstant _fcpxs (%i+ $focpx $ffsgl))
(defconstant _fcpxc (%i+ $focpx $ffcomp))
(defconstant _fcpxi (%i+ $focpx $ffint))
(defconstant _fcpxl (%i+ $focpx $fflng))

(defconstant $fcsnan 1)
(defconstant $fcqnan 2)
(defconstant $fcinf  3)
(defconstant $fczero 4)
(defconstant $fcnorm 5)
(defconstant $fcdenorm 6)

(defconstant _fclasss (%i+ $foclass $ffsgl))
(defconstant _fclassd (%i+ $foclass $ffdbl))
(defconstant _fclassx (%i+ $foclass $ffext))

(defconstant $fbinvalid 0)
(defconstant $fbuflow 1)
(defconstant $fboflow 2)
(defconstant $fbdivzer 3)
(defconstant $fbinexact 4)
(defconstant $fbrndlo 5)
(defconstant $fbrndhi 6)
(defconstant $fblstrnd 7)
(defconstant $fbdbl 5)
(defconstant $fbsgl 6)

(defconstant _fgetenv $fogetenv)
(defconstant _fsetenv $fosetenv)

(defconstant _ftestxcp $fotestxcp)
(defconstant _fsetxcp $fosetxcp)
(defconstant _fprocentry $foprocentry)
(defconstant _fprocexit $foprocexit)
(defconstant _fgethv $fogethv)
(defconstant _fsethv $fosethv)

(defconstant _flnx #x0000)
(defconstant _flog2x #x0002)
(defconstant _fln1x #x0004)
(defconstant _flog21x #x0006)

(defconstant _fexpx #x000B)
(defconstant _fexp2x #x000A)
(defconstant _fexp1x #x000C)
(defconstant _fexp21x #x000E)
(defconstant _fexpwri #x8010)
(defconstant _fexpwry #x8012 )
(defconstant _fcompound #xC014)
(defconstant _fannuity #xC016)
(defconstant _fsinx #x0018)
(defconstant _fcosx #x001A)
(defconstant _ftanx #x001C)
(defconstant _fatanx #x001E)
(defconstant _frandomx #x0020)

(provide "SANETRAPS")

; End of SANEtraps.lisp
