Release notes for MCL 5.0b2/4.4b6
----------------------
Native kernel.

MCL is now distributed with an additional OSX-native shared library, which
is intended to augment the functionality of the traditional MCL kernel
when running under OSX.  The traditional kernel is still used under OS9
and is used to find and load the native kernel under OSX.

In order for MCL to use the native kernel:

1) OSX must be active
2) The file "pmcl-OSX-kernel" must be present in the same directory
as the traditional kernel (and under that exact name.)

If these conditions are both met when an MCL application starts, the
traditional kernel will transfer control to the native kernel and let
it initialize and provide services for the lisp; otherwise, the traditional
kernel will do so.  Since the native kernel can communicate more reliably
with the lower levels of OSX than the traditional kernel can, it's very
desirable that it be used under OSX.

Some of the problems that the native kernel's intended to solve are
more likely to affect users of multi-processor systems (on which previous
versions of MCL could be extremely unstable.)  Hopefully, the fixes
will benefit users of single-processor systems as well.

An early tester of the native kernel reported crashes (apparently
involving font/glyph operations) when it and certain clients of
Unsanity.com's "Application Enhancer" software were involved.  It isn't 
clear how the native kernel could be contributing to that problem, but it isn't
known with absolute certainty that it isn't doing so:  any feedback
on whether this problem still exists and on how it can be reproduced
would be helpful.

Crash logs may provide more useful information in the backtrace(s)!
When the native kernel's in use, other information in OSX crash logs
should be more accurate and helpful.  (OSX was reporting the exception
that incidentally occurred when MCL's exception handler failed to
handle an exception; crash logs should now show more information
about the -real- cause of program termination.)

Print-call-history gets possible output-stream arg, from Brendan Burns. The default is *debug-io*.

Fix for *use-pop-up-control* true and pop-up contained in subview of window.
Export *use-pop-up-control*.

Fix for *use-pop-up-control* true when enabling or disabling a pop-up with a title.

The initial value of *use-pop-up-control* is true when (osx-p).

Added special variable ccl::*dont-bring-all-windows-front*. The initial value is NIL.
 If you think that the current behavior upon application resume, which does bring
 all MCL windows frontwards, is not pleasing for some reason then set the variable to T. 
 Then, if the application is resumed by clicking on one of its windows, only the clicked window will come frontwards. OSX only.
 Also shift-click allows a one time override of the current behavior.

#. signals reader-error vs. error when *read-eval* is false

*pixels-per-inch-x*/y* are now once again 72 rather than -1, though what those values mean is a matter of some question.
 Seems like it should be a function of monitor resolution?

Macro with-aedescs fixed to be more politically correct.

ccl:examples;Appleevent-toolkit.lisp - fix when sending appleevent to self, fix in create-alias-list. 
Fixes in create-psn-target. Fixes in ccl:examples;drag-and-drop.lisp and
ccl:examples;drag-and-drop-examples;fred-drag.lisp (P.S. drag-and-drop-examples;* did not ship with previous 4.4bx releases.
 The folder is now included.)

The contribution "applescript_tools.lisp" from Tom Bonura has been included in the examples folder.
Usages of aedesc.datahandle have been changed to not do that. 
Still has problems. See below re: bugs.

There may be more problems with appleevents in other files such as ccl:sourceserver;anarchie-interface ... 
AEDescs have become semi opaque on OSX 10.2. That is, the record length is known but we cannot assume that
 the second long word is a handle. Use #_AEGetDescData and #_AEGetDescDataSize instead.

Modal-dialogs are no longer collapsable. They were collapsable in previous versions of MCL when the dialog
 had a grow-box as it does in select-item-from-list.

(view-mouse-position nil) is once again #@(0 0) when mouse is in upper left corner of the screen. 

Added function ccl::set-hide-command-key (&key (others nil) (char #\H) (modifier :option)) 
 To set a command key in the Hide MCL or Hide Others menu item in the application
 menu. Others T means set key for Hide Others.
 At startup MCL does (set-hide-command-key) so command-option-h will hide MCL (if (osx-p)).
 If you want a command key for Hide Others do e.g. (set-hide-command-key :others t :modifier :control).
 If you don't like the default behavior you can do e.g.:
   (set-command-key ccl::*execute-item* '(:shift #\H))
   (ccl::set-hide-command-key :modifier nil)
 

Fix display in Fred when extending selection horizontally causes scrolling. (OSX only, OS9 was fine)

Fix scrolling with up arrow or down arrow in a fred-window with a large fred-buffer
when near top or bottom. (OSX only, OS9 was fine)

Function window-color-p now does the right thing rather than always returning T.

Extend put-scrap to include @@ and @@@ and set these to the second and third most 
recently copied items. from Gary Warren King.

Some fixes to ccl:library;io-buffer.lisp to permit character i/o to binary streams.

Fix define-method-combination (long form) to put declarations, if any, in the right place.

Fix to with-fore-color such that it may precede with-back-color in the presence
of theme-background being true. i.e. 
(with-fore-color fore
  (with-back-color back
    ...))
will now work on OSX native.

Fix to 3d-buttons so that e.g. the "resample" button in the inspector will indicate the click 
upon a quick mouse click or when carriage return is typed. (OSX only, OS9 worked)

Dragging of pane-splitter in Fred is more responsive on OSX. Thanks to Toomas Altosaar.

Fix so that colored cells in table-dialog-items work again - from Gilles Bisson.

Fix remove-menu-items for pop-up-menu such that removing the default-item when
it is the last item does not error. (old bug)

Fix to buffer-remove-unused-fonts (old bug) From: "Takehiko Abe" <keke@gol.com>

Fix to FRED search when the string one is searching for does exist but
crosses the "gap" in the fred buffer. (very old bug!)

OSX native change such that when a window that has been collapsed/swooped to the dock
is the second window in the window list, it does not un-swoop when the front
window is closed. It stays in the dock and the third window (if any) comes frontwards.


MCL on OSX native now deactivates the close, zoom, and collapse boxes when a window
is deactivated. This is not "standard" OSX behavior. If you don't like it,
set the variable ccl::*disable-bubbles-on-inactive-windows* to nil.

Fix compiler-macro for make-array to evaluate dims before the rest. (very old bug)

There is no longer a Quit menu item in the File menu when osx-p. It's in the Application menu.

Fix function %float2x in the file Lib;ff-source.lisp. (very old bug - undetected prior to OSX)

Apropos-dialog truncates selection if any at first #\newline if any.

Set-menu-color-table does nothing if OSX.

In 4.4b5 the comment reader treated linefeed like newline by default for those who
have gotten source files from elsewhere that are #\linefeed terminated. No longer true in 4.4b6
(has some bugs), but if you wish to do that, set ccl::*linefeed-equals-newline* to t.
That only affects reading of comments.

Selecting a collapsed window from the windows menu uncollapses. Thank you.

Change so e.g. (ecase x (t 4)) and (ccase x (t 4)) do not error at compile time

Fix for possible negative fonts in Fred style-vectors - i.e. in  delete, copy, and paste.
We believe that negative font numbers only occur on OSX but not certain.
Also fix for copy/paste a scrap to/from another application when the scrap contains
more than one script and at least one of the scripts is a two byte script.

Some types of windows with grow-icon-p = nil do enable the collapse bubble on OSX.

Fix machine-type for OSX.
Added function %get-cfstring which is now used by the functions machine-owner and machine-instance.
From Shannon Spires.

Add some more keyboard-types and processor-types. Lose mention of FPU in machine-version.

Fix Interfaces Tools item palette to not put text in :item-display in the pop-up-menu
when *use-pop-up-control* is true. Achieved nothing and caused a warning.


Added function ccl::convert-string that
converts a string from one text encoding to another insofar as
source and destination encodings make sense.
(arabic to korean does not make sense, conversion from
Unicode to a specific language encoding such as MacRoman
will stop converting upon finding a character that
does not exist in the destination encoding).

The text encoding can be any one of:
#$kCFStringEncodingUnicode,
#$kCFStringEncodingUTF8,
#$kCFStringEncodingMacJapanese,
#$kCFStringEncodingMacRoman,
... 

Added function ccl::encoding-to-name which given a text encoding, returns a descriptive string.

Fix to avoid error on startup when MCL is launched via AppleScript.

Modal dialogs hide floating windows while in progress. Nested modal dialogs work better.

Choose-file-dialog now shows files of type "????" as well as type 0 when "TEXT" is requested.
Load also accepts files of type "????" as well as 0 and decides whether "TEXT" or "PFSL" based on 
the filename extension (aka pathname-type).

Open-application-document digests files of type "????" and 0 if pathname-type is acceptable.
Added plst 0 resource so double clicking .lisp or .cfsl files that have lost their files types will work.

Added (defparameter *repeat-command-keys* nil) - dont auto repeat command keys
  - set to T if you wish cmd keys to repeat.



Known bugs and deficiencies
---------------------------

No type of help is implemented.

Sleep wakeup stuff does not work OSX native because "wakeup events are part of Power Manager 2.0 
which is not fully implemented in Mac OS X".

Define-compiler-macro doesn't accept setf functions - never has.

All bugs and deficiencies mentioned in the 4.4b5 release notes still exist in 4.4b6.

The contrib applescript_tools (now in examples) does not work on OSX native for a simple script:
tell application "Finder" to open file "hd:foo" 
where the file does exist.
Works on OS 9.2.1 and Classic mode on 10.1.5 or 10.2.

