; -*- Mode: LIsp; Package: CCL; -*-

; run-tests.lisp - run CMU test suite & dump results to file

(in-package :ccl)

(defun now-string ()
  (multiple-value-bind (sec min hr day mo yr)
                       (decode-universal-time (get-universal-time))
    (format nil "~2,'0D-~2,'0D-~2,'0D|~2,'0D-~2,'0D-~2,'0D"
            (mod yr 100) mo day hr min sec)))

(defun go-for-it ()
  (let* ((file-name (format nil "Test Results ~A" (now-string)))
         (window (make-instance 'fred-window :window-title "Test Results"))
         (*standard-output* window))
    (format t "File \"~A\"~%" file-name)
    (format t "~&*compile-definitions* is ~A~%~%" *compile-definitions*)
    (load "home:tests;00 A TestSystem")
    (window-save-1 (window-key-handler window)
                   (merge-pathnames "home:" file-name)
                   :overwrite)
    (map-windows #'(lambda (w)
                     (unless (or (typep w 'listener)
                                 (eq w window))
                       (window-close w))))))

(go-for-it)

; End of run-tests.lisp
