

;;	Change History (most recent first):
;;  3 8/25/97  akh  misc-set of dfloat array signals error when appropriate
;;  6 2/19/96  akh  add pad nops at end of file
;;                   fix dfloat case of misc-set - use cr7, index is in arg_y
;;  5 12/22/95 gb   fix misc_set/bitvector case
;;  4 11/19/95 gb   memoized store fix
;;  3 11/14/95 gb   misc_set bignums better
;;  (do not edit before this line!!)
;;; Vector reference.

;; Replacing the MCRXR with (MTXER rzero)
;; --------- 5.0 final
;; 04/15/97 bill The @sfloat case in misc_set now stores the new value instead of
;;               the 0th element of the array.
;; ------------- 4.1b2
;; 02/20/96 gb   NOPs now in sp_end.s
;; 11/17/95 gb   memoized node-set stores through loc-g, not memo.

	include	'lisp.s'

	import ksignalerr
	import box_signed
	import box_unsigned
	import .SPxuuo_interr
	import .SPfinish_alloc
	
;;; like misc_ref, only the boxed subtag is in arg_x.
subtag_misc_ref:	spentry subtag_misc_ref
	leaf_trap_unless_uvector arg_y,imm0
	leaf_trap_unless_fixnum arg_z,imm0
	vector_length imm0,arg_y,imm1
	cmplw arg_z,imm0
	unbox_fixnum imm1,arg_x
	bge vref_oob
	b misc_ref_common
vref_oob:
	mr temp0,arg_y
	mr arg_y,arg_z
	mr arg_z,temp0
	li arg_x,XARROOB
	set_nargs 3
	b ksignalerr
	
;;; Reference index arg_z of a misc-tagged object (arg_y).
;;; Note that this conses in some cases.  Return a properly-tagged
;;; lisp object in arg_z.  Do type and bounds-checking.
misc_ref:	spentry misc_ref
	leaf_trap_unless_uvector arg_y,imm0
	leaf_trap_unless_fixnum arg_z,imm0
	vector_length imm0,arg_y,imm1
	cmplw arg_z,imm0
	extract_lowbyte imm1,imm1	# imm1 = subtag
	bge vref_oob

misc_ref_common:	
	extract_fulltag imm2,imm1
	cmpwi cr0,imm2,fulltag_nodeheader
	cmpwi cr1,imm1,max_32_bit_ivector_subtag
	cmpwi cr2,imm1,max_8_bit_ivector_subtag
	addi imm0,arg_z,misc_data_offset
	bne cr0,@imm
	;; A node vector.
	lwzx arg_z,arg_y,imm0
	blr
@imm:	bgt cr1,@not32
	cmpwi cr1,imm1,subtag_single_float_vector
	cmpwi cr0,imm1,subtag_s32_vector
	lwzx imm0,arg_y,imm0
	beq cr1,@sfloat
	beq cr0,@signed
@unsigned:
	srawi. imm1,imm0,31-nfixnumtagbits
	box_fixnum arg_z,imm0
	beqlr cr0
	b box_unsigned
@signed:
	mtxer rzero
	addo imm1,imm0,imm0
	addo. arg_z,imm1,imm1
	bnslr
	b box_signed
@sfloat:
	li imm1,(1<<num_subtag_bits)|subtag_single_float
	ref_global extra,heap_limit
	la freeptr,single_float.size(freeptr)
	leaf_do_xalloc
	la arg_z,fulltag_misc(initptr)
	stw imm1,single_float.header(arg_z)
	stw imm0,single_float.value(arg_z)
	mr initptr,freeptr
	blr
@not32:	cmpwi cr1,imm1,max_16_bit_ivector_subtag
	bgt cr2,@not8
	;; 8-bit objects are either u8, s8, or base_strings.
	;; cr2_eq is set if base_string (= max_8_bit_ivector_subtag)
	cmpwi cr1,imm1,subtag_s8_vector
	srwi imm0,arg_z,2
	la imm0,misc_data_offset(imm0)
	lbzx imm0,arg_y,imm0
	beq cr2,@char
	bne cr1,@box
	extsb imm0,imm0
@box:	box_fixnum arg_z,imm0
	blr
@char:	slwi arg_z,imm0,charcode_shift
	ori arg_z,arg_z,subtag_character
	blr
@not8:	cmpwi cr2,imm1,subtag_bit_vector
	bgt cr1,@not16
	;; 16-bit objects are either u16, s16, or general_strings.
	;; cr1_eq is set if s16_vector (= max_16_bit_ivector_subtag)
	cmpwi cr0,imm1,subtag_simple_general_string
	srwi imm0,arg_z,1
	la imm0,misc_data_offset(imm0)
	lhzx imm0,arg_y,imm0
	beq cr0,@char
	bne cr1,@box
	extsh imm0,imm0
	b @box
@not16:	bne cr2,@dfloat
	extrwi imm1,arg_z,5,32-(fixnumshift+5)	# imm1 = bitnum
	la imm1,1+fixnumshift(imm1)
	rlwinm imm0,arg_z,32-5,5,31-fixnumshift
	la imm0,misc_data_offset(imm0)
	lwzx imm0,arg_y,imm0
	rlwnm arg_z,imm0,imm1,31-fixnumshift,31-fixnumshift
	blr
@dfloat:
	slwi imm0,arg_z,1
	la imm0,misc_dfloat_offset(imm0)
	la imm1,4(imm0)
	lwzx imm0,arg_y,imm0
	lwzx imm1,arg_y,imm1
	li imm2,(double_float.element_count<<num_subtag_bits)|subtag_double_float
	ref_global extra,heap_limit
	la freeptr,double_float.size(freeptr)
	leaf_do_xalloc
	la arg_z,fulltag_misc(initptr)
	stw imm2,double_float.header(arg_z)
	stw imm0,double_float.value(arg_z)
	stw imm1,double_float.value+4(arg_z)
	mr initptr,freeptr
	blr

;;; like misc_set, only pass the (boxed) subtag in temp0
subtag_misc_set:	spentry subtag_misc_set
	leaf_trap_unless_uvector arg_x,imm0
	leaf_trap_unless_fixnum arg_y,imm0
	vector_length imm0,arg_x,imm1
	cmplw arg_y,imm0
	unbox_fixnum imm1,temp0
	bge vset_oob
	b misc_set_common
vset_oob:
	mr arg_z,arg_x
	set_nargs 3
	li arg_x,XARROOB
	b ksignalerr

	import .SPwrite_barrier
;;; misc_set (vector index newval) : if a node object, may need to
;;; memoize the assignment.  Otherwise, pretty damned similar to
;;; misc_ref, as one might imagine.
misc_set:	spentry misc_set
	leaf_trap_unless_uvector arg_x,imm0
	leaf_trap_unless_fixnum arg_y,imm0
	vector_length imm0,arg_x,imm1
	cmplw arg_y,imm0
	extract_lowbyte imm1,imm1
	bge vset_oob
misc_set_common:	
	extract_fulltag imm2,imm1
	cmpwi cr0,imm2,fulltag_nodeheader
	cmpwi cr1,imm1,max_32_bit_ivector_subtag
	cmpwi cr2,imm1,max_8_bit_ivector_subtag
	addi imm0,arg_y,misc_data_offset
	bne cr0,@imm
	;; A node vector. If value is other than fixnum, tag_imm, nil,
	;; need to memoize for EGC.
	cmpw cr0,arg_z,rnil
	extract_lisptag imm2,arg_z
	cmpwi cr1,imm2,tag_imm
	cmpwi cr2,imm2,tag_fixnum
	beq cr0,@simple
	beq cr1,@simple
	beq cr2,@simple
	add loc_g,arg_x,imm0
	stw arg_z,0(loc_g)
	b .SPwrite_barrier
@simple:
	stwx arg_z,arg_x,imm0
	blr
@imm:	extract_lisptag imm2,arg_z
	cmpwi cr7,imm2,tag_misc
	cmpwi cr5,imm2,tag_fixnum
	bgt cr1,@not32
	cmpwi cr1,imm1,subtag_single_float_vector
	cmpwi cr0,imm1,subtag_s32_vector
	beq cr1,@sfloat
	beq cr0,@signed
	;; Either a non-negative fixnum, a one-digit bignum, or a two-digit
	;; bignum whose sign-digit is 0 is ok.
	srawi. imm1,arg_z,fixnum_shift
	bne cr5,@not_fixnum_u32
	blt cr0,@bad
@set32:	
	stwx imm1,arg_x,imm0
	blr
@not_fixnum_u32:
	bne cr7,@bad
	extract_header imm2,arg_z
	cmpwi cr0,imm2,one_digit_bignum_header
	cmpwi cr1,imm2,two_digit_bignum_header
	vref32 imm1,arg_z,0
	cmpwi cr2,imm1,0
	bne cr0,@not_1_digit
	bge cr2,@set32
	b @bad
@not_1_digit
	bne cr1,@bad
	vref32 imm2,arg_z,1
	cmpwi cr0,imm2,0
	bne cr1,@bad
	beq cr0,@set32
@bad:
	;; arg_z doesn't match the array-element-type of arg_x.
	mr arg_y,arg_z
	mr arg_z,arg_x
	li arg_x,XNOTELT
	set_nargs 3
	b ksignalerr
@signed:
	unbox_fixnum imm1,arg_z
	beq cr5,@set32
	bne cr7,@bad
	extract_header imm2,arg_z
	cmpwi cr0,imm2,one_digit_bignum_header
	vref32 imm1,arg_z,0
	bne cr0,@bad
	stwx imm1,arg_x,imm0
	blr
@sfloat:
	bne cr7,@bad
	extract_header imm2,arg_z
	cmpwi cr0,imm2,single_float_header
        bne cr0,@bad
	lwz imm1,single_float.value(arg_z)
	stwx imm1,arg_x,imm0
	blr
	
@not32:	cmpwi cr1,imm1,max_16_bit_ivector_subtag
	bgt cr2,@not8
	;; 8-bit objects are either u8, s8, or base_strings.
	;; cr2_eq is set if base_string (= max_8_bit_ivector_subtag)
	cmpwi cr1,imm1,subtag_s8_vector
	extract_lisptag imm2,arg_z
	srwi imm0,arg_y,2
	la imm0,misc_data_offset(imm0)
	extract_unsigned_byte_bits. imm1,arg_z,8
	beq cr2,@char8
	beq cr1,@signed8
	unbox_fixnum imm1,arg_z
	bne cr0,@bad
	stbx imm1,arg_x,imm0
	blr
@char8:	extract_lowbyte imm2,arg_z
	cmpwi cr2,imm2,subtag_character
	srwi imm1,arg_z,charcode_shift
	bne cr2,@bad
	stbx imm1,arg_x,imm0
	blr
@signed8:
	unbox_fixnum imm1,arg_z
	extsb imm2,imm1
	cmpw cr0,imm2,imm1
	bne cr5,@bad
	bne cr0,@bad
	stbx imm1,arg_x,imm0
	blr
@not8:	cmpwi cr2,imm1,subtag_bit_vector
	bgt cr1,@not16
	;; 16-bit objects are either u16, s16, or general_strings.
	;; cr1_eq is set if s16_vector (= max_16_bit_ivector_subtag)
	cmpwi cr0,imm1,subtag_simple_general_string
	srwi imm0,arg_y,1
	la imm0,misc_data_offset(imm0)
	beq cr1,@s16
	beq cr0,@char16
	extract_unsigned_byte_bits. imm1,arg_z,16
	unbox_fixnum imm1,arg_z
	bne cr0,@bad
	sthx imm1,arg_x,imm0
	blr
@s16:	unbox_fixnum imm1,arg_z
	extsh imm2,imm1
	cmpw cr0,imm2,imm1
	bne cr5,@bad
	bne cr0,@bad
	sthx imm1,arg_x,imm0
	blr
@char16: extract_lowbyte imm2,arg_z
	cmpwi cr0,imm2,subtag_character
	srwi imm1,arg_z,charcode_shift
	bne cr0,@bad
	sthx imm1,arg_x,imm0
	blr
@not16:	bne cr2,@dfloat
	;; Bit vector case.
	cmplwi cr2,arg_z,fixnumone   # nothing not a (boxed) bit 
	extrwi imm1,arg_y,5,32-(fixnumshift+5)	# imm1 = bitnum
	extlwi imm2,arg_z,1,31-fixnumshift
	srw imm2,imm2,imm1
	lis imm3,0x8000
	rlwinm imm0,arg_y,32-5,5,31-fixnumshift
	la imm0,misc_data_offset(imm0)
	srw imm3,imm3,imm1
	bgt cr2,@bad
	lwzx imm1,arg_x,imm0
	andc imm1,imm1,imm3
	or imm1,imm1,imm2
	stwx imm1,arg_x,imm0
	blr

@dfloat:	
	bne cr7,@bad		; not tag_misc
	extract_header imm2,arg_z
	cmpwi cr0,imm2,double_float_header
        slwi imm0,arg_y,1  ; imm0 gets index * 2
	la imm0,misc_dfloat_offset(imm0) ; + offset
	bne cr0,@bad
	lwz imm1,double_float.value(arg_z) ; get value parts
	lwz imm2,double_float.value+4(arg_z)
	stwx imm1,arg_x,imm0
	la imm0,4(imm0)
	stwx imm2,arg_x,imm0
	blr
